local SummonRandomMount = {name = "SummonRandomMount", version = 1, lastSummonedMount = 0, updateMountUpdate = "SummonRandomMount_updateMount", newMountID = 0}

function SummonRandomMount.ChooseMount(eventCode, mounted)
	EVENT_MANAGER:UnregisterForUpdate(SummonRandomMount.updateMountUpdate)
	if mounted then return end
	local numUnlockedMounts = GetTotalUnlockedCollectiblesByCategoryType(COLLECTIBLE_CATEGORY_TYPE_MOUNT)
	if numUnlockedMounts < 2 then return end
	SummonRandomMount.lastSummonedMount = GetActiveCollectibleByType(COLLECTIBLE_CATEGORY_TYPE_MOUNT)
	local numMounts = GetTotalCollectiblesByCategoryType(COLLECTIBLE_CATEGORY_TYPE_MOUNT)
	local unlockedMounts = {}
	for mountCollectible = 1, numMounts do
		local collectibleID = GetCollectibleIdFromType(COLLECTIBLE_CATEGORY_TYPE_MOUNT, mountCollectible)
		if IsCollectibleUnlocked(collectibleID) and collectibleID ~= SummonRandomMount.lastSummonedMount then
			unlockedMounts[#unlockedMounts+1] = collectibleID
			if #unlockedMounts + 1 >= numUnlockedMounts then break end
		end
	end
	local newMountIndex = math.random(#unlockedMounts)
	for tableIndex, mountID in pairs(unlockedMounts) do
		if tableIndex == newMountIndex then SummonRandomMount.newMountID = unlockedMounts[tableIndex] break end
	end
	if SummonRandomMount.newMountID == 0 then return end
	local _, cooldownDuration = GetCollectibleCooldownAndDuration(SummonRandomMount.newMountID)
	EVENT_MANAGER:RegisterForUpdate(SummonRandomMount.updateMountUpdate, cooldownDuration + 50, SummonRandomMount.ChangeMount)
end

function SummonRandomMount.ChangeMount()
	EVENT_MANAGER:UnregisterForUpdate(SummonRandomMount.updateMountUpdate)
	UseCollectible(SummonRandomMount.newMountID)
end

function SummonRandomMount.OnAddOnLoaded(event, addonName)
	if addonName == SummonRandomMount.name then
		EVENT_MANAGER:UnregisterForEvent(SummonRandomMount.name, EVENT_ADD_ON_LOADED)
		EVENT_MANAGER:RegisterForEvent(SummonRandomMount.name, EVENT_MOUNTED_STATE_CHANGED, SummonRandomMount.ChooseMount)
	end
end

EVENT_MANAGER:RegisterForEvent(SummonRandomMount.name, EVENT_ADD_ON_LOADED, SummonRandomMount.OnAddOnLoaded)
